Mounted disks don't always load
Description

| have been seeing some strange disk loading behavior for the past few builds. Intermittently, when | mount a disk and cold reset the
computer, it behaves like no disk is present and goes to the memo pad/self test. | haven't been able to consistently reproduce it but it
seems like it might be related to some combination of mounting a disk and switching between XL/XE and 400/800. | have to try
changing mounted disks and changing OSs a few times before it starts working again.

History

#1 - 08/23/2018 08:40 PM - foft
- Priority changed from Normal to High

Probably about time [ fix this, might be impacting some atx loading too.

#2 - 08/26/2018 08:45 PM - foft

Setting up the logic analyser to check the cause of the first few fails on the scanalyzer...

#3 - 08/26/2018 09:41 PM - foft

Hmmm, gets a failed checksum on the first sector read and switches to high speed sio. Then takes a while to resync.

Now need to see why | get a bad checksum (tomorrow).

#4 - 08/27/2018 09:22 PM - foft

So 3 problems...

i) Sometimes bad checksum, must be a sync issue with pokey clock | guess.

ii) Flip flopping between fast and slow too quickly to make sense.

iii) Seems to be very slow to ready 16 bytes from sd card (atr header), Atari send 3 command packets during this?! Need to work out what is going on
here, this makes no sense.

#5 - 08/27/2018 09:34 PM - foft
The time spent oniii is in pf_open, the fat file system open. | guess this must do some work.

Perhaps if | ack first then the Atari will give me more time to handle this in piece... This will mean with the current approach that code that accesses
drives in turn is slow, though is that common in practice? Probably not.

#6 - 08/28/2018 09:57 AM - foft

| guess a disk revolution at 288rpm is 200ms, so it must be ok timing wise to do the ack first.

#7 - 08/28/2018 09:45 PM - foft

Added more structure to the command handling (common ack/nak etc) and looking much better. More to do though...

#8 - 09/02/2018 09:53 PM - foft

Farb, are you still running into this with the latest builds?

#9 - 09/02/2018 10:01 PM - Farb

It doesn't seem to be happening as much although | did run into some weirdness a couple of times that might be related so I'll keep an eye on it.
#10 - 09/03/2018 09:31 AM - foft

Ok good. That's as | hoped. | still need to make switching from slow to fast sio and back more reliable, | just fixed something that made it enter that
state too often.
#11 - 09/13/2018 09:38 PM - foft

I'd added a 2ms delay temporarily to stop some fast/slow flip flopping. That actually breaks USB keyboard when in that state. Decreased it to 100us
for now, though really | need to get to the bottom of what is going on.

| have a cartridge (yes, not a disk!) that puts it into this state now, so have something easy to debug...

#12 - 09/20/2018 09:29 PM - foft

Implemented using sio clock out as the zpu clock input. Should mean it can listen to whatever speed. Though of course there is still the question of
what speed to reply at. Of course | do know what the pokey divisor is but it feels like cheating to use it:-)

#13 - 09/21/2018 10:53 PM - foft

On second thoughts, why guess when | know. Pokey is already outputting the serial input anyway (even in input mode, since its oe/in/out which is
then connected to the pin). Then | can remove all the divisor guessing logic and code.

#14 - 09/21/2018 11:48 PM - foft

Except | need to send start bit from zpu to start that clock. Probably a fairly simple state machine change, but getting too late now!

#15 - 09/25/2018 10:08 PM - foft

In the end | chose to use the SIO clock for receiving command packets. | also count the rate. Then | reply using the same rate, creating my own clock.
| also fixed the divisor selection, it was not using the valid from the menu!

Will do another day or so of testing, but think this is now good...

#16 - 09/26/2018 09:55 PM - foft

- Status changed from New to Closed

Closing as | think this is fixed in v29. Reopen if problems still seen!
